image: framasoft/framabook-generator:latest

stages:
  - preparation
  - build
  - test
  - publish
  - cleanup

getmakefile:
  stage: preparation
  rules:
    - if: '$CI_COMMIT_MESSAGE =~ /<[a-z]*>/'
      when: always
  script:
    - git clone --depth 1 https://framagit.org/framabook/systeme-publication-framabook.git
    - mv systeme-publication-framabook/makefile .
    - if [ -d "systeme-publication-framabook/scripts" ]; then
    - mv -n systeme-publication-framabook/scripts . ; fi
    - if [ -d "systeme-publication-framabook/templates" ]; then
    - mv -n systeme-publication-framabook/templates . ; fi
    - rm -Rf systeme-publication-framabook/
    - ls -al
    - ls -al src
  artifacts:
    paths:
      - ./
      - build/
      - deflate/
      - fromepub/
      - scripts/
      - src/
      - templates/
      - tmp/
      - work/

epub:
  stage: build
  rules:
    - if: '$CI_COMMIT_MESSAGE =~ /<epub>/'
      when: always
  script:
    - make all
  artifacts:
    paths:
      - build/*.epub

fromepub:
  stage: build
  rules:
    - if: '$CI_COMMIT_MESSAGE =~ /<fromepub>/'
      when: always
  script:
    - make allfromepub
  artifacts:
    paths:
      - build/*.epub

tex:
  stage: build
  rules:
    - if: '$CI_COMMIT_MESSAGE =~ /<tex>/'
      when: always
  script:
    - make tex
    - mkdir --parents build/tex
    - cp tex build/
  artifacts:
    paths:
      - build/tex

pdf:
  stage: build
  rules:
    - if: '$CI_COMMIT_MESSAGE =~ /<pdf>/'
      when: always
  script:
    - make pdf
  artifacts:
    paths:
      - build/*.pdf

content:
  stage: build
  rules:
    - if: '$CI_COMMIT_MESSAGE =~ /<content>/'
      when: always
  script:
    - if [ -d src/*.epub ]; then
    - make dezip
    - else
    - make firstpass
    - fi
    - make regexp
  artifacts:
    paths:
      - deflate/

rapport:
  stage: test
  rules:
    - if: '$CI_COMMIT_MESSAGE =~ /<rapport>/'
      when: always
  script:
    - make validate
  artifacts:
    paths:
      - build/epubcheck_report.json
      - build/ace_reports/

cloud:
  stage: publish
  rules:
    - if: '$CI_COMMIT_MESSAGE =~ /<cloud>/'
      when: always
  script:
    - rm -f files.txt
    - rm -f folders.txt
    - 'titre=$(grep "^title:" src/informations.yaml | sed -s "s@title: \([^\#]*\).*@\1@" | sed -r "s/ /_/g"| sed -r "s/^(.*)_/\1/g" |tr "[:upper:]" "[:lower:]")'
    - echo $titre >> folders.txt
    - cd build
    - find -type d \( ! -name . \) -exec bash -c "echo $titre/{} | sed 's/\.\///' >> ../folders.txt" \;
    - find -type f \( ! -name . \) -exec bash -c "echo {} | sed 's/\.\///' >> ../files.txt" \;
    - cd ..
    - sort -d -o folders.txt folders.txt
    - for folder in $(cat folders.txt) ; do
    - 'curl --fail --silent --output /dev/null --user "$NEXTCLOUD_ID:$NEXTCLOUD_PWD" -X PROPFIND "https://cloud.framabook.org/remote.php/dav/files/framagitlab-ci/Ouvrages/$folder" > /dev/null || echo "$folder doesn’t exist on remote, creating it" ; curl --user "$NEXTCLOUD_ID:$NEXTCLOUD_PWD" -X MKCOL "https://cloud.framabook.org/remote.php/dav/files/framagitlab-ci/Ouvrages/$folder" || exit 1'
    - done
    - for file in $(cat files.txt) ; do
    - echo "Copying file $file to remote"
    - 'curl --user "$NEXTCLOUD_ID:$NEXTCLOUD_PWD" -T build/$file "https://cloud.framabook.org/remote.php/dav/files/$NEXTCLOUD_ID/Ouvrages/$titre/$file" || exit 1'
    - done
    - rm -f files.txt
    - rm -f folders.txt
  artifacts:
    paths:
      - build/*

publish:
  stage: publish
  rules:
    - if: '$CI_COMMIT_MESSAGE =~ /<publish>/'
      when: always
  script:
    - echo "Déploiement à venir - TBD"
  artifacts:
    paths:
      - build/*
